Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestEntry/FrmEntryReqSelRequest.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestEntry/FrmEntryReqSelRequest.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestEntry/FrmEntryReqSelRequest.cs	(revision 60)
@@ -0,0 +1,1013 @@
+﻿using System;
+using System.Collections;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+
+using ProcessManagement.Common;
+using ProcessManagement.DataModel;
+using ProcessManagement.DB;
+using ProcessManagement.DB.IOAccess;
+using ProcessManagement.Forms.SubForms;
+using ProcessManagement.Forms.ControlsAction;
+
+
+namespace ProcessManagement.Forms.DataEntry
+{
+    public partial class FrmEntryReqSelRequest : Form
+    {
+        #region 使用定義
+        //log4netログを使用する
+        private static readonly log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
+        #endregion
+
+        #region 定数
+
+        /// <summary>
+        /// チェック結果
+        /// </summary>
+        enum CheckState
+        {
+            Ok = 0,
+            Warning,
+            Error,
+        }
+        #endregion
+
+        #region 変数
+
+        private bool m_bEditFlg = true;             // 編集モード
+        private int m_nInvoiceNo = 0;               // 請求書No
+        private int m_nRequestMonth = 0;            // 請求月
+        private int m_nOrderersDivision = 0;        // 発注者区分
+        private int m_nOrderersCode = 0;            // 発注者コード
+        private string m_strOrderersName = "";      // 発注者名
+        private int m_nOldSelectedValue = 0;
+
+        // 請求ヘッダ
+        private List<RequestHead> m_lstReqHead = new List<RequestHead>();
+
+        // 請求書データ
+        private Dictionary<int, InvoiceData> m_dicInvData = new Dictionary<int, InvoiceData>();
+
+        #endregion
+
+        #region プロパティ
+
+        public bool EditFlg
+        {
+            get { return m_bEditFlg; }
+            set { m_bEditFlg = value; }
+        }
+        public int InvoiceNo
+        {
+            get { return m_nInvoiceNo; }
+            set { m_nInvoiceNo = value; }
+        }
+        public int RequestMonth
+        {
+            get { return m_nRequestMonth; }
+            set { m_nRequestMonth = value; }
+        }
+        public int OrderersDivision
+        {
+            get { return m_nOrderersDivision; }
+            set { m_nOrderersDivision = value; }
+        }
+        public int OrderersCode
+        {
+            get { return m_nOrderersCode; }
+            set { m_nOrderersCode = value; }
+        }
+        public string OrderersName
+        {
+            get { return m_strOrderersName; }
+            set { m_strOrderersName = value; }
+        }
+
+        #endregion
+
+        #region コンストラクタ
+        public FrmEntryReqSelRequest()
+        {
+            InitializeComponent();
+        }
+        #endregion
+
+        #region フォームのロード
+        private void FrmEntryReqSelRequest_Load(object sender, EventArgs e)
+        {
+            dgv1.EnableHeadersVisualStyles = false;
+            dgv1.AutoGenerateColumns = false;
+            dgv1.ColumnHeadersHeight = 28;
+            dgv1.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
+            dgv1.AllowUserToAddRows = false;
+            dgv1.RowTemplate.Height = 24;
+            dgv1.Font = new System.Drawing.Font("ＭＳ 明朝", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
+            dgv1.ColumnHeadersDefaultCellStyle.BackColor = Color.Aquamarine;
+
+            int yyyy = CommonMotions.cnvTruncate((double)m_nRequestMonth / 100);
+            int mm = m_nRequestMonth % 100;
+            lbReqMonth.Text = string.Format("{0}/{1}", yyyy, mm.ToString("D2"));
+            lbOrderersName.Text = m_strOrderersName;
+
+            // 請求書データ取得
+            GetInvoiceData();
+
+            List<int> lstCreateData = new List<int>();
+
+            if (m_nInvoiceNo == 0)
+            {
+                // 作成日コンボの取得
+                SetRequestCreateDateAll();
+            }
+            else
+            {
+                // 作成日コンボの取得
+                SetRequestCreateDateOnly();
+            }
+
+            cbCreateDate.SelectedIndex = 0;
+
+            // 請求データ取得
+            GetReqestData();
+
+            // 請求データ表示
+            DispRequestData();
+
+            // 請求書が指定されている場合は、チェックボックス変更に関わる操作は許可しない
+            if (m_nInvoiceNo > 0)
+            {
+                btnAllSelect.Enabled = false;
+                btnAllUnselect.Enabled = false;
+            }
+            UpdateCheckValue(0);
+
+            dgv1.Rows[0].Visible = false;
+
+        }
+        #endregion
+
+        #region [全選択]ボタン押下
+        private void btnAllSelect_Click(object sender, EventArgs e)
+        {
+            int nInvoiceNo = int.Parse(cbCreateDate.SelectedValue.ToString());
+
+            dgv1.CellContentClick -= dgv1_CellContentClick;
+            dgv1.CellContentDoubleClick -= dgv1_CellContentDoubleClick;
+
+            for (int i = 1; i < dgv1.Rows.Count; i++)
+            {
+                // 請求ヘッダが紐づいていない行はダミー
+                if (dgv1[4, i].Value == null)
+                {
+                    break;
+                }
+
+                // 請求書が紐づいていないものはON
+                if (dgv1[5, i].Value == null)
+                {
+                    dgv1[0, i].Value = true;
+                }
+                // 請求書が紐づいていても選択されている請求書のものはON
+                else if (int.Parse(dgv1[5, i].Value.ToString()) == nInvoiceNo)
+                {
+                    dgv1[0, i].Value = true;
+                }
+            }
+
+            // 選択数、選択金額の更新
+            UpdateCheckValue(0);
+
+            dgv1.CellContentClick += dgv1_CellContentClick;
+            dgv1.CellContentDoubleClick += dgv1_CellContentDoubleClick;
+
+        }
+        #endregion
+
+        #region [全選択解除]ボタン押下
+        private void btnAllUnselect_Click(object sender, EventArgs e)
+        {
+            int nInvoiceNo = int.Parse(cbCreateDate.SelectedValue.ToString());
+
+            for (int i = 1; i < dgv1.Rows.Count; i++)
+            {
+                // 請求ヘッダが紐づいていない行はダミー
+                if (dgv1[4, i].Value == null)
+                {
+                    break;
+                }
+
+                // 請求書が紐づいていないものはOFF
+                if (dgv1[5, i].Value == null)
+                {
+                    dgv1[0, i].Value = false;
+                }
+                // 請求書が紐づいていても選択されていない請求書のものはOFF
+                else if (int.Parse(dgv1[5, i].Value.ToString()) != nInvoiceNo)
+                {
+                    dgv1[0, i].Value = false;
+                }
+            }
+            // 選択数、選択金額の更新
+            UpdateCheckValue(0);
+        }
+        #endregion
+
+        #region [削除]ボタン押下
+        private void btnDel_Click(object sender, EventArgs e)
+        {
+            if (MessageBox.Show("表示されている請求書を削除しますがよろしいですか？", "削除確認", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.No)
+            {
+                return;
+            }
+
+            int nInvoiceNo = int.Parse(cbCreateDate.SelectedValue.ToString());
+
+            // 請求書データの削除
+            if (DeleteInvoiceData(nInvoiceNo) == false)
+            {
+                return;
+            }
+
+            foreach (RequestHead ReqHead in m_lstReqHead)
+            {
+                if (ReqHead.InvoiceNo == nInvoiceNo)
+                {
+                    ReqHead.InvoiceNo = 0;
+                }
+            }
+
+            for (int i = 0; i < dgv1.Rows.Count; i++)
+            {
+                // 請求ヘッダが紐づいていない行はダミー
+                if (dgv1[4, i].Value == null)
+                {
+                    break;
+                }
+
+                // 削除対象の設計書データが紐づいている場合
+                if ((dgv1[5, i].Value != null) && (int.Parse(dgv1[5, i].Value.ToString()) == nInvoiceNo))
+                {
+                    dgv1[5, i].Value = null;
+                    dgv1[3, i].Value = null; 
+                }
+
+            }
+
+            // 請求データから該当請求書を削除
+            m_dicInvData.Remove(nInvoiceNo);
+
+            cbCreateDate.SelectedIndexChanged -= cbCreateDate_SelectedIndexChanged;
+
+            cbCreateDate.DataSource = null;
+            cbCreateDate.Items.Clear();
+
+            // 作成日コンボの取得
+            SetRequestCreateDateAll();
+
+            cbCreateDate.SelectedIndexChanged += cbCreateDate_SelectedIndexChanged;
+
+            cbCreateDate.SelectedIndex = 0;
+
+
+            RefleshRequestList(nInvoiceNo);
+
+        }
+        #endregion
+
+        #region [請求書作成]ボタン押下
+        private void btnGenerate_Click(object sender, EventArgs e)
+        {
+            int ret;
+            string msg = "";
+
+            // 作成チェック
+            ret  = CheckGenerate(ref msg);
+
+            if (ret == (int)CheckState.Ok)
+            {
+                if (MessageBox.Show(msg, "登録確認", MessageBoxButtons.YesNo, MessageBoxIcon.Question) != DialogResult.Yes)
+                {
+                    return;
+                }
+            }
+            else if (ret == (int)CheckState.Warning)
+            {
+                if (MessageBox.Show(msg, "登録確認", MessageBoxButtons.YesNo, MessageBoxIcon.Warning) != DialogResult.Yes)
+                {
+                    return;
+                }
+            }
+            else
+            {
+                MessageBox.Show(msg, "登録確認", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                return;
+            }
+
+            // データの登録
+            m_nInvoiceNo = EntryData();
+
+            DialogResult = DialogResult.OK;
+
+            // 画面クローズ
+            Close();
+        }
+        #endregion
+
+        #region [終了]ボタン押下
+        private void btnEnd_Click(object sender, EventArgs e)
+        {
+            // 画面クローズ
+            Close();
+        }
+        #endregion
+
+        #region 作成日コンボの選択変更
+        private void cbCreateDate_SelectedIndexChanged(object sender, EventArgs e)
+        {
+            int nInvoiceNo = int.Parse(cbCreateDate.SelectedValue.ToString());
+
+            if (m_nOldSelectedValue == nInvoiceNo)
+            {
+                return;
+            }
+
+            m_nOldSelectedValue = nInvoiceNo;
+
+            RefleshRequestList(nInvoiceNo);
+        }
+
+        #endregion
+
+        #region 一覧の更新
+
+        private void RefleshRequestList( int nInvoiceNo )
+        {
+            bool bEnabled = false;
+
+            // 新規以外が選択された場合
+            if (nInvoiceNo != 0)
+            {
+                InvoiceData InvData = null;
+                if (m_dicInvData.TryGetValue(nInvoiceNo, out InvData) == true)
+                {
+                    if (InvData.CompleteFlg == 0)
+                    {
+                        bEnabled = true;
+                    }
+                }
+            }
+
+            btnDel.Enabled = bEnabled;
+
+            for (int i = 1; i < dgv1.Rows.Count; i++)
+            {
+                // 請求ヘッダが紐づいていない行はダミー
+                if (dgv1[4, i].Value == null)
+                {
+                    break;
+                }
+
+                // 新規請求書が選択された場合は全OFF
+                if (nInvoiceNo == 0)
+                {
+                    dgv1[0, i].Value = false;
+                    dgv1[0, i].ReadOnly = false;
+                }
+                else
+                {
+                    // 請求書が選択された場合は該当設計書のみON
+                    if ((dgv1[5, i].Value != null) && (int.Parse(dgv1[5, i].Value.ToString()) == nInvoiceNo))
+                    {
+                        dgv1[0, i].Value = true;
+                        dgv1[0, i].ReadOnly = true;
+
+                    }
+                    else
+                    {
+                        dgv1[0, i].Value = false;
+                        dgv1[0, i].ReadOnly = false;
+                    }
+                }
+            }
+            // 選択数、選択金額の更新
+            UpdateCheckValue(0);
+        }
+
+        #endregion
+
+        #region セル内容のクリック
+        private void dgv1_CellContentClick(object sender, DataGridViewCellEventArgs e)
+        {
+            UpdateCheckValue(e.ColumnIndex); 
+        }
+        #endregion
+
+        #region セル内容のWクリック
+        private void dgv1_CellContentDoubleClick(object sender, DataGridViewCellEventArgs e)
+        {
+            UpdateCheckValue(e.ColumnIndex); 
+        }
+        #endregion
+
+        #region 選択数、選択金額の更新
+        void UpdateCheckValue(int tcol)
+        {
+            int cnt = 0;
+            int val;
+            int amount = 0;
+
+            for (int i = 1; i < dgv1.Rows.Count; i++)
+            {
+                if (dgv1[tcol, i].EditedFormattedValue.Equals(true) == true)
+                {
+                    cnt++;
+
+                    if (dgv1[2, i].Value != null)
+                    {
+                        val = int.Parse(dgv1[2, i].Value.ToString().Replace(",", string.Empty));
+                    }
+                    else
+                    {
+                        val = 0;
+                    }
+
+                    amount += val;
+                }
+            }
+
+            lbSelect.Text = cnt.ToString("#,0");
+            lbTotalAmount.Text = amount.ToString("#,0");
+        }
+        #endregion
+
+        #region 請求書データの取得
+        private void GetInvoiceData()
+        {
+            IOInvoiceData ioInvData = new IOInvoiceData();
+
+            ArrayList arData = new ArrayList();
+
+            try
+            {
+                string sql = "SELECT";
+                sql += " InvData.InvoiceNo";
+                sql += " ,InvData.OrderersDivision";
+                sql += " ,InvData.OrderersCode";
+                sql += " ,InvData.RequestMonth";
+                sql += " ,InvData.SeqNo";
+                sql += " ,DATE_FORMAT(InvData.CretateDate, '%Y/%m/%d')";
+                sql += " ,DATE_FORMAT(InvData.RequestDate, '%Y/%m/%d')";
+                sql += " ,InvData.RequestName";
+                sql += " ,InvData.TotalAmount";
+                sql += " ,InvData.TaxAmount";
+                sql += " ,InvData.Comment1";
+                sql += " ,InvData.Comment2";
+                sql += " ,InvData.Comment3";
+                sql += " ,InvData.Comment4";
+                sql += " ,InvData.Comment5";
+                sql += " ,InvData.CompleteFlg";
+                sql += " ,DATE_FORMAT(InvData.EntryDate, '%Y/%m/%d %H:%i:%s')";
+                sql += " ,DATE_FORMAT(InvData.UpdateDate, '%Y/%m/%d %H:%i:%s')";
+                sql += " FROM";
+                sql += " InvoiceData InvData";
+                sql += string.Format(" WHERE InvData.OrderersDivision = {0}", m_nOrderersDivision);
+                sql += string.Format(" AND InvData.OrderersCode = {0} ", m_nOrderersCode);
+                sql += string.Format(" AND InvData.RequestMonth = {0} ", m_nRequestMonth);
+                sql += " AND EXISTS( SELECT * FROM RequestHead ReqHead WHERE ReqHead.InvoiceNo = InvData.InvoiceNo )";
+                sql += " ORDER BY InvData.CretateDate Asc, InvData.SeqNo Asc";
+
+                // SQL実行
+                if (!ioInvData.ExecuteReader(sql, ref arData, true)) return;
+
+                // データセット
+                foreach (object[] objwrk in arData)
+                {
+                    InvoiceData work = new InvoiceData();
+                    ioInvData.Reader2Struct(objwrk, ref work);
+
+                    m_dicInvData.Add(work.InvoiceNo, work);
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                ioInvData.close();
+                ioInvData = null;
+            }
+            return;
+        }
+        #endregion
+
+        #region 請求データの取得
+
+        private void GetReqestData()
+        {
+
+            IORequestHead ioReqHead = new IORequestHead();
+
+            try
+            {
+                List<RequestHead> lstWork = new List<RequestHead>();
+
+                string sql = string.Format(" Where RequestMonth = {0}",m_nRequestMonth); 
+                sql += string.Format(" And OrderersDivision = {0}", m_nOrderersDivision);
+                sql += string.Format(" And OrderersCode = {0}", m_nOrderersCode);
+                sql += string.Format(" And OrderersName = '{0}'", m_strOrderersName);
+                sql += " And AssignedFlg = 0";
+                sql += " Order by ReqConstructionCode Asc, OrderNo Asc";
+
+                if (ioReqHead.SelectAction(sql, ref lstWork) == false)
+                {
+                    return;
+                }
+
+                foreach (RequestHead ReqHead in lstWork)
+                {
+                    // 最終承認済
+                    if (ClsApprovalPermission.CheckApprovalData(ReqHead.ReqConstructionCode, (int)ClsExcute.ApprovalListNo.OrderBillingApproval, ReqHead.OrderNo) == false)
+                    {
+                        continue;
+                    }
+
+                    // 請求ヘッダの追加
+                    m_lstReqHead.Add(ReqHead);
+
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                ioReqHead.close();
+                ioReqHead = null;
+            }
+        }
+        #endregion
+
+        #region 請求データの表示
+
+        private void DispRequestData()
+        {
+            int nCount = m_lstReqHead.Count;
+            if (nCount < 10)
+            {
+                nCount = 10;
+            }
+
+            // 行を追加
+            dgv1.Rows.Add(nCount+1);
+
+            int trow = 1;
+            foreach (RequestHead ReqHead in m_lstReqHead)
+            {
+                // 請求書Noが指定されている場合は、チェックボックスの変更不可
+                if (m_nInvoiceNo == 0)
+                {
+                    dgv1[0, trow].ReadOnly = false;
+                }
+
+                dgv1[1, trow].Value = ReqHead.ReqConstructionName;
+                dgv1[2, trow].Value = ReqHead.RequestTotalAmount.ToString("#,0");
+                dgv1[4, trow].Value = ReqHead.RequestNo;
+
+                if (ReqHead.InvoiceNo > 0)
+                {
+                    InvoiceData InvData = null;
+
+                    if (m_dicInvData.TryGetValue(ReqHead.InvoiceNo, out InvData) == true)
+                    {
+                        dgv1[3, trow].Value = InvData.CretateDate.ToString("yyyy/MM/dd");
+                        dgv1[5, trow].Value = InvData.InvoiceNo;
+                    }
+
+                }
+                trow++;
+            }
+        }
+
+        #endregion
+
+        #region 作成日コンボの設定
+        private void SetRequestCreateDateAll()
+        {
+            List<int> lstKeyInvNo = new List<int>(m_dicInvData.Keys);
+            Dictionary<string, List<InvoiceData>> dicWork = new Dictionary<string, List<InvoiceData>>();
+            List<KeyValuePair<int, string>> lstKeyVal = new List<KeyValuePair<int, string>>();
+
+            foreach (int nInvoiceNo in lstKeyInvNo)
+            {
+                InvoiceData InvData = null;
+                if (m_dicInvData.TryGetValue(nInvoiceNo, out InvData) == true)
+                {
+                    string strDate = InvData.CretateDate.ToString("yyyy/MM/dd");
+
+                    List<InvoiceData> lstWork = null;
+
+                    if (dicWork.TryGetValue(strDate, out lstWork) == false)
+                    {
+                        lstWork = new List<InvoiceData>();
+
+                        dicWork.Add(strDate, lstWork);
+                    }
+                    lstWork.Add(InvData);
+                }
+            }
+            
+            List<string> lstKeyDate = new List<string>(dicWork.Keys);
+
+            KeyValuePair<int, string> KeyValNew = new KeyValuePair<int, string>(0, "新規");
+            lstKeyVal.Add(KeyValNew);
+
+            foreach (string strDate in lstKeyDate)
+            {
+                List<InvoiceData> lstWork = null;
+
+                if (dicWork.TryGetValue(strDate, out lstWork) == true)
+                {
+                    for (int i = 0; i < lstWork.Count; i++)
+                    {
+                        string strValue;
+
+                        strValue = strDate;
+                        if (i > 0)
+                        {
+                            strValue += string.Format("({0})", i);
+                        }
+
+                        KeyValuePair<int, string> KeyVal = new KeyValuePair<int, string>(lstWork[i].InvoiceNo, strValue);
+
+                        lstKeyVal.Add(KeyVal);
+                    }
+                }
+            }
+
+            cbCreateDate.ValueMember = "Key";
+            cbCreateDate.DisplayMember = "Value";
+
+            // コンボボックス初期表示
+            ComboBoxAction.InitDataSetCombBox(cbCreateDate, lstKeyVal, false);
+                                    
+            return;
+        }
+
+        private void SetRequestCreateDateOnly()
+        {
+
+            List<KeyValuePair<int, string>> lstKeyVal = new List<KeyValuePair<int, string>>();
+            InvoiceData InvData = null;
+
+            if (m_dicInvData.TryGetValue(m_nInvoiceNo, out InvData) == true)
+            {
+                string strDate = InvData.CretateDate.ToString("yyyy/MM/dd");
+
+                KeyValuePair<int, string> KeyVal = new KeyValuePair<int, string>(InvData.InvoiceNo, strDate);
+
+                lstKeyVal.Add(KeyVal);
+            }
+
+            cbCreateDate.ValueMember = "Key";
+            cbCreateDate.DisplayMember = "Value";
+
+            // コンボボックス初期表示
+            ComboBoxAction.InitDataSetCombBox(cbCreateDate, lstKeyVal, false);
+
+            return;
+        }
+
+        #endregion
+
+        #region 作成チェック
+        private int CheckGenerate(ref string msg)
+        {
+            int nInvoiceNo = int.Parse(cbCreateDate.SelectedValue.ToString());
+
+            int nSelect = int.Parse(lbSelect.Text.ToString());
+            int nRet = (int)CheckState.Ok;
+
+            // 選択なし
+            if (nSelect == 0)
+            {
+                msg = "請求件名が選択されていません";
+
+                return (int)CheckState.Error;
+            }
+
+            int tcol = 0;
+            for (int i = 1; i < dgv1.Rows.Count; i++)
+            {
+                // 請求ヘッダが紐づいていない行はダミー
+                if (dgv1[4, i].Value == null)
+                {
+                    break;
+                }
+
+                // 選択れている場合
+                if (dgv1[tcol, i].EditedFormattedValue.Equals(true) == true)
+                {
+                    if (dgv1[5, i].Value == null)
+                    {
+                        continue;
+                    }
+
+                    if (int.Parse(dgv1[5, i].Value.ToString()) != nInvoiceNo)
+                    {
+                        nRet = (int)CheckState.Warning;
+                        break;
+                    }
+                }
+            }
+
+            if (nRet == (int)CheckState.Warning)
+            {
+                msg = "他で請求されている請求件名が選択されています。\nこの内容で請求書を作成してよろしいですか？";
+                return nRet;
+            }
+
+            for (int i = 1; i < dgv1.Rows.Count; i++)
+            {
+                // 請求ヘッダが紐づいていない行はダミー
+                if (dgv1[4, i].Value == null)
+                {
+                    break;
+                }
+
+
+                // 選択れている場合
+                if (dgv1[tcol, i].EditedFormattedValue.Equals(true) == true)
+                {
+                    if (dgv1[5, i].Value != null)
+                    {
+                        continue;
+                    }
+
+                    if (InvoiceNo > 0)
+                    {
+                            msg = "既に作成済の請求書に新規請求件名を追加します。\nこの内容で請求書を作成してよろしいですか？";
+                            nRet = (int)CheckState.Warning;
+                            break;
+                    }
+                }
+            }
+
+
+            if (nRet == (int)CheckState.Ok)
+            {
+                msg = "この内容で請求書を作成してよろしいですか？";
+            }
+
+            return nRet;
+            
+        }
+        #endregion
+
+        #region 請求書データ登録
+
+        private int EntryData()
+        {
+            int nInvoiceNo = int.Parse(cbCreateDate.SelectedValue.ToString());
+
+            List<RequestHead> lstReqHead = new List<RequestHead>();
+
+            int tcol = 0;
+            for (int i = 1; i < dgv1.Rows.Count; i++)
+            {
+                // 請求ヘッダが紐づいていない行はダミー
+                if (dgv1[4, i].Value == null)
+                {
+                    break;
+                }
+
+                // 選択れている場合
+                if (dgv1[tcol, i].EditedFormattedValue.Equals(true) == true)
+                {
+                    lstReqHead.Add(m_lstReqHead[i-1]);
+                }
+            }
+
+            // 請求書データの登録
+            nInvoiceNo = AddInvoiceData(nInvoiceNo, lstReqHead);
+
+            return nInvoiceNo;
+        }
+
+        #endregion
+
+        #region 請求書データの登録
+
+        private int AddInvoiceData(int nInvoiceNo, List<RequestHead> lstReqHead)
+        {
+            IOInvoiceData ioInvData = new IOInvoiceData();
+            IORequestHead ioReqHead = new IORequestHead();
+
+            InvoiceData InvData = null;
+
+
+            ioInvData.beginTran();
+            ioReqHead.beginTran();
+
+            try
+            {
+                // 請求書Noが指定されていない場合
+                if (nInvoiceNo == 0)
+                {
+                    // 請求書Noの採番
+                    nInvoiceNo = ioInvData.NumberingInvoiceNo(m_nRequestMonth);
+                    if (nInvoiceNo == -1)
+                    {
+                        // DBロールバック
+                        ioInvData.rollback();
+                        ioReqHead.rollback();
+
+                        return -1;
+                    }
+
+                    // 請求書データ構築
+                    InvData = new InvoiceData();
+
+                    InvData.InvoiceNo = nInvoiceNo;
+                    InvData.OrderersDivision = m_nOrderersDivision;
+                    InvData.OrderersCode = m_nOrderersCode;
+                    InvData.RequestMonth = m_nRequestMonth;
+                    InvData.SeqNo = ioInvData.NumberingSeqNo(m_nOrderersDivision, m_nOrderersCode,m_nRequestMonth);
+                    InvData.CretateDate = DateTime.Now;
+                    InvData.RequestDate = DateTime.MinValue;
+                    InvData.RequestName = m_strOrderersName;
+                    InvData.TotalAmount = 0;
+                    InvData.TaxAmount = 0;
+
+                    // 請求書データの挿入
+                    if (ioInvData.InsertAction(InvData) == false)
+                    {
+                        // DBロールバック
+                        ioInvData.rollback();
+                        ioReqHead.rollback();
+
+                        return -1;
+                    }
+                }
+                else
+                {
+                    // 請求書データの取得
+                    if (m_dicInvData.TryGetValue(nInvoiceNo, out InvData) == false)
+                    {
+                        // DBロールバック
+                        ioInvData.rollback();
+                        ioReqHead.rollback();
+                        return -1;
+                    }
+
+                    // 作成日のみ更新
+                    InvData.CretateDate = DateTime.Now;
+                    InvData.TotalAmount = 0;
+                    InvData.TaxAmount = 0;
+
+                    // 請求書データの更新
+                    string sql = string.Format(" Where InvoiceNo = {0}", nInvoiceNo);
+                    if (ioInvData.UpdateAction(sql, InvData) == false)
+                    {
+                        // DBロールバック
+                        ioInvData.rollback();
+                        ioReqHead.rollback();
+
+                        return -1;
+                    }
+                }
+
+                // 選択されている請求ヘッダの請求書Noを更新
+                foreach (RequestHead ReqHead in lstReqHead)
+                {
+                    ReqHead.InvoiceNo = nInvoiceNo;
+                }
+                if (ioReqHead.UpdateAction(lstReqHead) == false)
+                {
+                    // DBロールバック
+                    ioInvData.rollback();
+                    ioReqHead.rollback();
+
+                    return -1;
+                }
+
+                // DBコミット
+                ioInvData.commit();
+                ioReqHead.commit();
+
+                return nInvoiceNo;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return -1;
+            }
+            finally
+            {
+                ioInvData.close();
+                ioInvData = null;
+                ioReqHead.close();
+                ioReqHead = null;
+            }
+        }
+
+        #endregion
+
+        #region 請求書配下の金額を取得
+        private void GetReqHeadAmount(List<RequestHead> lstReqHead, ref int nTotalAmount, ref int nTaxAmount)
+        {
+            foreach (RequestHead ReqHead in lstReqHead)
+            {
+                nTotalAmount += ReqHead.RequestTotalAmount;
+                nTaxAmount += ReqHead.TaxAmount;
+            }
+            return;
+        }
+        #endregion
+
+        #region 請求データの削除
+        private bool DeleteInvoiceData(int nInvoiceNo)
+        {
+            string sql = "";
+
+            IOInvoiceData ioInvData = new IOInvoiceData();
+            IORequestHead ioReqHead = new IORequestHead();
+
+            ioInvData.beginTran();
+            ioReqHead.beginTran();
+
+            try
+            {
+                // 請求書データの削除
+                sql = string.Format(" Where InvoiceNo = {0}", nInvoiceNo);
+                if (ioInvData.DeleteAction(sql) == false)
+                {
+                    ioInvData.rollback();
+                    ioReqHead.rollback();
+
+                    return false;
+                }
+
+                List<RequestHead> lstReqHead = new List<RequestHead>();
+
+                sql = string.Format(" Where InvoiceNo = {0}", nInvoiceNo);
+                if (ioReqHead.SelectAction(sql, ref lstReqHead) == false)
+                {
+                    ioInvData.rollback();
+                    ioReqHead.rollback();
+
+                    return false;
+                }
+
+                // 請求ヘッダの請求書Noをクリア
+                foreach (RequestHead ReqHead in lstReqHead)
+                {
+                    ReqHead.InvoiceNo = 0;
+
+                    
+                }
+
+                // 請求ヘッダを更新
+                if (ioReqHead.UpdateAction(lstReqHead) == false)
+                {
+                    ioInvData.rollback();
+                    ioReqHead.rollback();
+
+                    return false;
+
+                }
+
+                ioInvData.commit();
+                ioReqHead.commit();
+
+                return true; 
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                ioInvData.close();
+                ioInvData = null;
+                ioReqHead.close();
+                ioReqHead = null;
+            }
+
+        }
+        #endregion
+
+    }
+}
